/*-----------------------------------------------------------------------------------
$Id: test_format_double.c,v 1.10 2012/03/06 08:54:23 wolf Exp wolf $
-----------------------------------------------------------------------------------*/

/*
**	ACHTUNG!!!
**
**	Verwendet printf(%f) und libm.o
**
**	Nur zum Test auf der Entwicklungsmaschine, nicht auf dem ARM!
*/

#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "format_double.h"

/*
**	Teste die Formatierroutine mit einem Wert
**
**	konvertiere mit "%f" und mit formatDouble
**	zeige beide Ergebnisse
*/

static void
test (double value) {
	printf ("[%s]\t%20.6g\t%12.6f\n",
		formatDouble (NULL, value, 0, 10),
		value,
		value);
}

/*
**	Rufe den Test mit verschiedenen Werten auf
*/

int
main (int argn, char** argv) {
	int i;
	double d;
	printf ("formatDouble\t\t\t%%20.6g\t\t%%12.6f\n");
	test (0);
	test (0.25);
	test (0.5);
	test (1.0);
	test (-1.0);
	test (2.0);
	test (4.0);
	for (d=1.234567890123456789e-6; d<1e14; d*=10.0) test (d);
	test (-1.234567890123456789e12);
	test (-1.234567890123456789e11);
	test (-1.234567890123456789e10);
	for (i=0; i<30; i++) test (exp ((rand()-RAND_MAX/2) * (70.0 / RAND_MAX)) * (rand()&1 ? 1.0 : -1.0));
	return 0;
}

/*-----------------------------------------------------------------------------------
$Id: test_format_double.c,v 1.10 2012/03/06 08:54:23 wolf Exp wolf $
-----------------------------------------------------------------------------------*/
