/*-----------------------------------------------------------------------------------
$Id: test_regression1.c,v 1.2 2012/03/06 08:54:23 wolf Exp wolf $
-----------------------------------------------------------------------------------*/

#include <stdio.h>
#include <stdlib.h>
#include "regression.h"

#define POINTS (50)		/* nur genutzt wenn nicht in regression.h definiert */

/*
**	Verwendet printf(%f)
**
**	Nur zum Test auf der Entwicklungsmaschine, nicht auf dem ARM!
*/

static	t_regression rcb;

#ifndef REGRESSION_POINTS
static	double buffer[POINTS];
#endif

int main () {

	int i;

	/* Initialisiere den Kontrollblock */

#ifdef REGRESSION_POINTS
	regressionInit (&rcb);
#else
	regressionInit (&rcb, POINTS, buffert);
#endif

	/* Kontrollblock */

	printf ("Zeit        Wert   Geglättet  Qual   Änderung   Zukunft  Vorhersage\n");
	for (i=0; i<100; i++) {
		double mean, change, quality, forecast;
		/* linear ansteigender, aber verrauschter Wert */
		double value = i + 2.0 * (rand() - 0.5 * RAND_MAX) / (RAND_MAX/2);
		/* füge hinzu */
		regressionAdd (&rcb, (double)i, value);
		/* frage die Werte ab */
		mean	= regressionActual (&rcb);
		change	= regressionChange (&rcb);
		quality	= regressionQuality (&rcb);
		/* Voraussage für den Wert zehn Zeiteinheiten weiter */
		forecast= regressionForecast (&rcb, i+20);
		/* Zeige den ganzen Mist an */
		printf ("%4i%12.3f%12.3f%6.2f  %9.2f      %4i%12.3f\n", i, value, mean, quality, change, i+20, forecast);
	}
	return 0;
}

/*-----------------------------------------------------------------------------------
$Id: test_regression1.c,v 1.2 2012/03/06 08:54:23 wolf Exp wolf $
-----------------------------------------------------------------------------------*/
